/** \file easynirwrapper.h
 *  \brief \b Ƕӿ.
 *  \author wangdh
 *  \version 1.0
 *  \date 2020-03-18 15:10:00
 *  \details \b 
 *  - ǲӿ
 *	- ǻ
 */

#ifndef EASY_NIR_WRAPPER_H
#define EASY_NIR_WRAPPER_H

#include <map>
#include <list>
#include <vector>

#ifdef __cplusplus
extern "C"
{
#endif
	/**
	 * \brief öӵϵͳdlp豸.
	 * \param[out] num 豸
	 * \return >= 0:öٳɹ, < 0:öʧ.
	 */
	int enumerateDevices(int* num);

	/**
	 * \brief ӵϵͳ豸.
	 * \param[in] index Ҫ򿪵豸,ЧΧ0~(N-1)֮(NΪöٵ豸).
	 * \return >= 0:򿪳ɹ, < 0:ʧ.
	 */
	int openSpectrometer(int index);

	/**
	 * \brief رӵϵͳ豸.
	 */
	void closeSpectrometer();

	/**
	 * \brief ȡ豸ɨò
	 * \return ɨò
	 */
	int getScanSectionNumber();

	/**
	 * \brief ȡ豸ɨ
	 * \param[in] index 豸ɨ(οgetScanSectionNumber() indexСgetScanSectionNumber()ֵ)
	 * \param[out] secName 豸ɨ
	 * \param[in] size 豸ɨڴС
	 * \return 0:ȡɹ, <0:ȡʧ
	 */
	int getScanSectionName(int index, char* secName, unsigned int size);

	/**
	 * \brief ȡĳһɨúеɨø
	 * \param name ɨ
	 * \return ɨø
	 */
	int getScanSectionNameNumber(char* name);

	/**
	 * \brief ȡɨ
	 * \param name ɨ
	 * \param index ɨ
	 * \param scanType ɨ
	 * \param scanTypeLen ɨڴ泤
	 * \param widthPixel ؿ
	 * \param wavelengthStart ʼɨСλΪ
	 * \param wavelengthEnd ɨСλΪ
	 * \param patternsNum Ƶĵ
	 * \param exposureTime عʱ
	 * \return 0:ȡɹ, <0:ȡʧ
	 */
	int getScanSectionNameCfg(char* name, int index, char* scanType, unsigned int scanTypeLen, double* widthPixel,
		unsigned short* wavelengthStart, unsigned short* wavelengthEnd,
		unsigned short* patternsNum, double* exposureTime);

	/**
	 * \brief ȡ豸ɨ
	 * \return 
	 */
	int getScanTypesNumber();

	/**
	 * \brief ȡ豸ɨ
	 * \param index (οgetScanTypesNumber() indexСgetScanTypesNumber()ֵ)
	 * \return ɨ
	 */
	char* getScanTypesName(int index);

	/**
	 * \brief ȡؿ͸
	 * \return ؿ͸
	 */
	int getWidthPixelsNumber();

	/**
	 * \brief ȡؿ
	 * \param index ؿ(οgetWidthPixelsNumber() indexСgetWidthPixelsNumber()ֵ)
	 * \return ؿ
	 */
	double getWidthPixel(int index);

	/**
	 * \brief ȡعʱ͸
	 * \return عʱ͸
	 */
	int getExposureTimesNumber();

	/**
	 * \brief ȡعʱ
	 * \param index ؿ(οgetExposureTimesNumber() indexСgetExposureTimesNumber()ֵ)
	 * \return عʱ
	 */
	double getExposureTime(int index);

	/**
	 * \brief ȡʣģʽ
	 * \param cfgName[in] ļ
	 * \param section[in] ǰɨ
	 * \param num[out] ʣģʽ(ȥǰ)
	 * \return 0:ȡɹ, <0:ȡʧ
	 */
	int getRemainPatternNum(char* cfgName, unsigned char section, unsigned short* num);

	/**
	 * \brief ȡģʽΧ
	 * \param[out] start ʼ
	 * \param[out] end 
	 * \return 0:ȡɹ, <0:ȡʧ
	 */
	int getPatternsRange(int* start, int* end);

	/**
	 * \brief ȡĲ
	 * \param[out] index 
	 * \return 0:ȡɹ, <0:ȡʧ.
	 */
	int getActiveScanIndex(int* index);

	/**
	 * \brief ûĲ
	 * \param[in] index 
	 * \return 0:óɹ, <0:ʧ.
	 */
	int setActiveScanIndex(char index);

	/**
	 * \brief ȡɨԤʱ䣨룩
	 * \return Ԥʱ䣨룩
	 */
	int getEstimatedScanTime();

	/**
	 * \brief Ŀò
	 * \param name ò
	 * \param section ɨ
	 * \param scanType ɨ
	 * \param wavelengthStart ʼ
	 * \param wavelengthEnd 
	 * \param widthPixel ؿ
	 * \param patternsNum ģʽ
	 * \param exposureTime عʱ
	 * \return 0:óɹ, <0:ʧ
	 */
	int setTgtCfg(const char* name, int section, const char* scanType, unsigned short wavelengthStart,
		unsigned short wavelengthEnd, double widthPixel, unsigned short patternsNum,
		double exposureTime);

	/**
	  * \brief Ŀò
	  * \param cfgName ò
	  * \param averNum ɨ
	  * \return 0:óɹ, <0:ʧ
	  */
	int setTgtCfgs(const char* cfgName, unsigned short averNum);

	/**
	 * \brief Ƴɨ
	 * \param name ɨ
	 * \return 0:Ƴɹ, <0:Ƴʧ
	 */
	int removeTgtCfg(const char* name);

	/**
	 * \brief ȡ汾
	 * \param[out] pTivaSwVersion Tiva汾
	 * \param[out] pDlpcswVersion DLP汾
	 * \param[out] pDlpcFlashBuildVersion flash汾
	 * \param[out] pSpecLibVer ǿ汾
	 * \param[out] pCalDataVer У׼汾
	 * \param[out] pRefCalDataVer ο汾
	 * \param[out] pCfgDataVer ò汾
	 * \return 0:ȡȷ <0:ȡʧ
	 */
	int getVersions(unsigned int *pTivaSwVersion, unsigned int *pDlpcswVersion, unsigned int *pDlpcFlashBuildVersion, unsigned int *pSpecLibVer, unsigned int *pCalDataVer, unsigned int *pRefCalDataVer, unsigned int *pCfgDataVer);

	/**
	 * \brief ùԴ״̬
	 * \param[in] status 1: 0:
	 * \return 0:óɹ, <0:ʧ
	 */
	int setLampStatus(int status);
		
	/**
	 * \brief ϵ
	 * \param[in] isFixed 1:̶ 0:̶
	 * \param[in] gainVal 1,2,4,8,16,32  64
	 * \return true:óɹ, false:ʧ
	 */
	int setPGAGain(int isFixed, unsigned char gainVal);

	/**
	 * \brief ȡģʽ
	 * \param[in] cfg_name 
	 * \param[out] start_nm ʼ
	 * \param[out] end_nm 
	 * \param[out] width_index ؿ
	 * \param[out] scan_type ɨ
	 * \param[out] scan_num ɨ
	 * \return ģʽ
	 */
	int getMaxPattern(char* cfg_name, int start_nm, int end_nm, unsigned char width_index, int scan_type, unsigned char scan_num);

	/**
	 * \brief ȡݳ
	 * \param[out] fileSize ݳ
	 * \return >= 0:ȡȷ < 0:ȡʧ
	 */
	int getFormattedSpectrumLengths(int* fileSize);

	/**
	 * \brief ùǲɼƽ
	 * \param[in] time ƽ
	 * \return 0:óɹ, <0:ʧ
	 */
	int setSpectrumAverageTime(unsigned short time);

	/**
	 * \brief ȡ.
	 * \param[out] pWavelength 
	 * \param[out] pData 
	 * \param[out] dataSize ݳ
	 * \return >= 0:ȡȷ < 0:ȡʧ
	 */
	int getFormattedSpectrum(double *pWavelength, int *pData, int *dataSize);

	/**
	 * \brief ȡһεĴϢ.
	 * \return Ϣ[󳤶Ϊ256ֽ]
	 */
	const char* getLastException();

	/**
	 * \brief ־.
	 * \param[in] onOff 1:־ 0:ر־
	 */
	void setLogSwitch(int onOff);


#ifdef __cplusplus
}
#endif

#endif//EASY_NIR_WRAPPER_H
